/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include <nnhk.h>
#include <troj3d.h>

#include <stdio.h>
#include <time.h>
#include <math.h>

#include "hra.h"

#include <windows.h> /* Sleep() */

#define CLOCKS_PER_MS (CLOCKS_PER_SEC / 1000.0)

int main()
{
    HRA hra;
    NNHK_OKNO *okno;
    NNHK_POVRCH *povrch;
    int cyklus;
    double cshas_za_sniimku; /* V ms. */
    double akumulovanee_ms = 0;

    nnhk_inic();

    okno = nnhk_VytvorOkno("Obycshajnyy nadpis",
                           0, 0, 640, 480,
                           NNHK_OKNO_VIDITHELNEE);

    if (okno == NULL) printf("zle!\n");

    povrch = nnhk_dajOknaPovrch(okno);

    if (povrch == NULL) printf("zle!!\n");

    hraInit(&hra, okno);

    nnhk_OknoNastavChytenie(okno, 1);
    hra.v_hre = 1;

    cyklus = 1;
    while (cyklus)
    {
        clock_t shtart = clock();

        while(akumulovanee_ms >= CSHAS_TIKU)
        {
            if(hraTik(&hra))
            {
                cyklus = 0;
                break;
            }

            akumulovanee_ms -= CSHAS_TIKU;
        }

        hraKresli(&hra, povrch->pixely);

        nnhk_aktualizujOkno(okno);

        /* Limituje SZS na 60. */
        cshas_za_sniimku = (clock() - shtart) / CLOCKS_PER_MS;
        if (cshas_za_sniimku < 16)
        {
            Sleep((16 - cshas_za_sniimku));
        }

        cshas_za_sniimku = (clock() - shtart) / CLOCKS_PER_MS;
        akumulovanee_ms += cshas_za_sniimku;
    }

    hraKoniec(&hra);

    nnhk_ZnicshOkno(okno);

    nnhk_koniec();

    return (0);
}

