/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include <nnhk.h>
#include <troj3d.h>

#define CSHANK_SHIIRKA 16
#define CSHANK_VYYSHKA 256
#define CSHANK_DLLZHKA 16

typedef struct {
    int x;
    int y;
    int z;
} IVEKT;

typedef struct {
    unsigned long farba;
    int vidithelhnyy;
} BLOK;

typedef struct {
    BLOK bloky[CSHANK_SHIIRKA][CSHANK_VYYSHKA][CSHANK_DLLZHKA];
    TROJUH trojuhy[50000];
    int n_trojuhy;
} CSHANK;

typedef struct {
    VEKTOR poz; /* Nohy. */
    VEKTOR rot;
    VEKTOR v;
} HRAACSH;

typedef struct {
    NNHK_OKNO *okno;
    int shiirka;
    int vyyshka;
    int zornee_pole; /* V stupnhoch. */
    KAMERA *kamera;
    IVEKT cshankyIPoz;
    CSHANK ***cshankZoznam;
    HRAACSH *hraacsh;
    int v_hre; /* 1, ak nie je hra v menu. */
} HRA;

void hraInit(HRA *hra, NNHK_OKNO *okno);
void hraKoniec(HRA *hra);

#define CSHAS_TIKU 50

void hraKresli(HRA *hra, void *sniimka);
int hraTik(HRA *hra);
