/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#ifndef TROJ3D_H
#define TROJ3D_H

#include <stdio.h>
#include "vektor.h"
#include "kamera.h"

typedef struct {
    double x;
    double y;
    double z;
} VRCHOL;

typedef struct {
    VRCHOL vrcholy[3];
    unsigned long farba;
} TROJUH;

void kameraInic(KAMERA *kamera, VEKTOR *poz, VEKTOR *rot, VEKTOR *div);

void zobrazTrojuhy(KAMERA *kamera,
                   void *sniimka, int shiirka, int vyyshka,
                   TROJUH *trojuhy, int pocshet);
void troj3dSniimka(void *sniimka, int shiirka, int vyyshka);

#endif /* TROJ3D_H */
