/*
 * RSH - Robte si hocičo
 *
 * Ktokoľvek a čokoľvek smie kopírovať, upravovať, zverejňovať,
 * používať, kompilovať, predávať a šíriť toto dielo
 * a všetky jeho časti v akejkoľvek podobe na akékoľvek účely,
 * komerčné a nekomerčné, bez akýchkoľvek obmedzení,
 * bez dodržiavania akýchkoľvek podmienok
 * a akýmikoľvek prostriedkami.
 *
 * Jeder und alles darf kopieren, bearbeiten, veröffentlichen,
 * verwenden, kompilieren, verkaufen und verbreiten dieses Werk
 * und alle seine Teile in irgendeiner Form für irgendeinen Zweck,
 * kommerziell und nichtkommerziell, ohne Beschränkungen,
 * ohne irgendwelche Bedingungen einzuhalten
 * und mit allen Mitteln.
 *
 * Anyone and anything may copy, edit, publish,
 * use, compile, sell and distribute this work
 * and all its parts in any form for any purpose,
 * commercial and non-commercial, without any restrictions,
 * without complying with any conditions
 * and by any means.
 */

#include "vektor.h"

#include <math.h>
#include <stdlib.h>

void vektorRotuj(VEKTOR *vektor, double rx, double ry, double rz)
{
    double x, m, y, z;

    x = cos(ry)*(sin(rz)*(vektor->y)+cos(rz)*(vektor->x))-sin(ry)*(vektor->z);
    m = (cos(ry)*(vektor->z)
         +sin(ry)*(sin(rz)*(vektor->y)+cos(rz)*(vektor->x)));
    y = sin(rx)*m+cos(rx)*(cos(rz)*(vektor->y)-sin(rz)*(vektor->x));
    z = cos(rx)*m-sin(rx)*(cos(rz)*(vektor->y)-sin(rz)*(vektor->x));

    vektor->x = x;
    vektor->y = y;
    vektor->z = z;
}

double uholMedziVektormi(VEKTOR *v1, VEKTOR *v2)
{
    double vrch = abs(v1->x * (v2->x)
                      + v1->y * (v2->y)
                      + v1->z * (v2->z));
    double spodok = (sqrt(v1->x * (v1->x)
                          + v1->y * (v1->y)
                          + v1->z * (v1->z))
                     * sqrt(v2->x * (v2->x)
                            + v2->y * (v2->y)
                            + v2->z * (v2->z)));

    return (acos(vrch / spodok));
}
